head-first-ruby-chapter-1/config/routes.rb
Rails.application.routes.draw do
  resources :events
  resources :tickets
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

head-first-ruby-chapter-1/app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

head-first-ruby-chapter-1/app/models/event.rb
class Event < ApplicationRecord
end

head-first-ruby-chapter-1/app/models/ticket.rb
class Ticket < ApplicationRecord
end

head-first-ruby-chapter-1/app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
end

head-first-ruby-chapter-1/app/controllers/events_controller.rb
class EventsController < ApplicationController
  before_action :set_event, only: [:show, :edit, :update, :destroy]

  # GET /events
  # GET /events.json
  def index
    @events = Event.all
  end

  # GET /events/1
  # GET /events/1.json
  def show
  end

  # GET /events/new
  def new
    @event = Event.new
  end

  # GET /events/1/edit
  def edit
  end

  # POST /events
  # POST /events.json
  def create
    @event = Event.new(event_params)

    respond_to do |format|
      if @event.save
        format.html { redirect_to @event, notice: 'Event was successfully created.' }
        format.json { render :show, status: :created, location: @event }
      else
        format.html { render :new }
        format.json { render json: @event.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /events/1
  # PATCH/PUT /events/1.json
  def update
    respond_to do |format|
      if @event.update(event_params)
        format.html { redirect_to @event, notice: 'Event was successfully updated.' }
        format.json { render :show, status: :ok, location: @event }
      else
        format.html { render :edit }
        format.json { render json: @event.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /events/1
  # DELETE /events/1.json
  def destroy
    @event.destroy
    respond_to do |format|
      format.html { redirect_to events_url, notice: 'Event was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_event
      @event = Event.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def event_params
      params.require(:event).permit(:artist, :description, :price_low, :price_high, :even_date)
    end
end

head-first-ruby-chapter-1/app/controllers/tickets_controller.rb
class TicketsController < ApplicationController
  before_action :set_ticket, only: [:show, :edit, :update, :destroy]

  # GET /tickets
  # GET /tickets.json
  def index
    @tickets = Ticket.all
  end

  # GET /tickets/1
  # GET /tickets/1.json
  def show
  end

  # GET /tickets/new
  def new
    @ticket = Ticket.new
  end

  # GET /tickets/1/edit
  def edit
  end

  # POST /tickets
  # POST /tickets.json
  def create
    @ticket = Ticket.new(ticket_params)

    respond_to do |format|
      if @ticket.save
        format.html { redirect_to @ticket, notice: 'Ticket was successfully created.' }
        format.json { render :show, status: :created, location: @ticket }
      else
        format.html { render :new }
        format.json { render json: @ticket.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /tickets/1
  # PATCH/PUT /tickets/1.json
  def update
    respond_to do |format|
      if @ticket.update(ticket_params)
        format.html { redirect_to @ticket, notice: 'Ticket was successfully updated.' }
        format.json { render :show, status: :ok, location: @ticket }
      else
        format.html { render :edit }
        format.json { render json: @ticket.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tickets/1
  # DELETE /tickets/1.json
  def destroy
    @ticket.destroy
    respond_to do |format|
      format.html { redirect_to tickets_url, notice: 'Ticket was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_ticket
      @ticket = Ticket.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def ticket_params
      params.require(:ticket).permit(:name, :seat_id_seq, :address, :price_pad, :email_address, :phone)
    end
end

head-first-ruby-chapter-1/app/helpers/application_helper.rb
module ApplicationHelper
end

head-first-ruby-chapter-1/app/helpers/events_helper.rb
module EventsHelper
end

head-first-ruby-chapter-1/app/helpers/tickets_helper.rb
module TicketsHelper
end

head-first-ruby-chapter-1/app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Tickets</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

head-first-ruby-chapter-1/app/views/tickets/_form.html.erb
<%= form_with(model: ticket, local: true) do |form| %>
  <% if ticket.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(ticket.errors.count, "error") %> prohibited this ticket from being saved:</h2>

      <ul>
      <% ticket.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name, id: :ticket_name %>
  </div>

  <div class="field">
    <%= form.label "Seat #" %>
    <%= form.text_field :seat_id_seq, id: :ticket_seat_id_seq %>
  </div>

  <div class="field">
    <%= form.label :address %>
    <%= form.text_area :address, id: :ticket_address %>
  </div>

  <div class="field">
    <%= form.label :price_pad %>
    <%= form.text_field :price_pad, id: :ticket_price_pad %>
  </div>

  <div class="field">
    <%= form.label :email_address %>
    <%= form.text_field :email_address, id: :ticket_email_address %>
  </div>

  <div class="field">
    <%= form.label :phone %>
    <%= form.text_field :phone, id: :ticket_phone %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

head-first-ruby-chapter-1/app/views/tickets/edit.html.erb
<h1>Editing Ticket</h1>

<%= render 'form', ticket: @ticket %>

<%= link_to 'Show', @ticket %> |
<%= link_to 'Back', tickets_path %>

head-first-ruby-chapter-1/app/views/tickets/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Tickets</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Seat #</th>
      <th>Address</th>
      <th>Price pad</th>
      <th>Email address</th>
      <th>Telephone Number</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @tickets.each do |ticket| %>
      <tr>
        <td><%= ticket.name %></td>
        <td><%= ticket.seat_id_seq %></td>
        <td><%= ticket.address %></td>
        <td><%= ticket.price_pad %></td>
        <td><%= ticket.email_address %></td>
        <td><%= ticket.phone %></td>
        <td><%= link_to 'Show', ticket %></td>
        <td><%= link_to 'Edit', edit_ticket_path(ticket) %></td>
        <td><%= link_to 'Destroy', ticket, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Ticket', new_ticket_path %>

head-first-ruby-chapter-1/app/views/tickets/new.html.erb
<h1>New Ticket</h1>

<%= render 'form', ticket: @ticket %>

<%= link_to 'Back', tickets_path %>

head-first-ruby-chapter-1/app/views/tickets/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @ticket.name %>
</p>

<p>
  <strong>Seat #:</strong>
  <%= @ticket.seat_id_seq %>
</p>

<p>
  <strong>Address:</strong>
  <%= @ticket.address %>
</p>

<p>
  <strong>Price paid:</strong>
  <%= @ticket.price_pad %>
</p>

<p>
  <strong>Email address:</strong>
  <%= @ticket.email_address %>
</p>

<p>
  <strong>Telephone number:</strong>
  <%= @ticket.phone %>
</p>

<%= link_to 'Edit', edit_ticket_path(@ticket) %> |
<%= link_to 'Back', tickets_path %>